.TH fsqp G "June 1997" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
findparam - utility function for fsqp solver
.SH  CALLING SEQUENCE
.nf
[nf,nineqn,nineq,neqn,neq,nfsr,ncsrl,ncsrn,mesh_pts,nf0,ng0,nc0,nh0,na0]=findparam(list_obj,list_cntr,x0)
.fi
.SH PARAMETERS
.TP 10
list_objs  
: list made of two lists.
.TP 10
list_cntr   
: list made of six lists.
.TP 10
x0  
: real column vector (e.g. initial guess)
.TP 10
nf, ..., ncsrn
: integers (see fsqp-doc).
.TP
mesh_pts 
: real vector.
.SH DESCRIPTION
Given a list of objective functions and a list of constraints
functions, and a vector x0, findparam returns useful fsqp
parameters.
The list of objectives should be: (use empty list when necessary: list() )
.nf
list_obj=list(...
               list(f_1,...,f_nf0),...     //regular objectives
	       list(F_1,...,F_nfsr)        //SR objectives
              )
.fi
The f_i's are functions: y=f_i(x) should return the value of the ith
regular objective as a function of x. y can be a column vector if
several regular objectives are stacked together.
y=F_i(x) is the ith sequentially related objective. y is a column
vector which contains the ith set of SR-objectives (mesh_pts(i) is
set to size(F_i(x),1) by findparam).
.LP
The list of constraints functions should be as follows:
.nf
list_cntr=list(...
	list(g_1,...,g_ng0),...     //regular nonlinear inequality
        list(G_1,...,G_ncsrn),...   //SR      nonlinear inequality
        list(c_1,...,c_nc0),...     //regular linear    inequality
        list(C_1,...,C_ncsrl),...   //SR      linear    inequality
        list(h_1,...,h_nh0),...     //nonlinear         equality
        list(A_1,...,A_na0)         //linear            equality
             )
.fi
Functions g_i's, c_i's, h_1 can return column vectors y (e.g. y=g_1(x)) 
if several constraints are stacked together.
Functions G_i's, C_i's, A_i's should return in a column vector the
set of appropriate SR constraints.
Examples are given at the end of examplei.sce files. See
listutils.sci: generic functions obj, cntr, grob, grcn are constructed
from the lists list_obj, list_cntr, and similar lists list_grobj
and list_cntr which contain the gradients of objectives and constraints
(matrices whith nparam=dim(x) columns).
.SH SEE ALSO
srfsqp, x_is_new, set_x_is_new

